
!SmalltalkImage methodsFor: '*SqSquare-BrowserPlugin' stamp: 'mu 4/19/2006 11:32'!
saveAsBrowserPlugin
	| newName |
	newName := 'SqueakPlugin.image'.
	(SourceFiles at: 2)
		ifNotNil: [self closeSourceFiles;
				saveChangesInFileNamed: (self fullNameForChangesNamed: newName)
			"so copying the changes file will always work"].
	self
		saveImageInFileNamed: (self fullNameForImageNamed: newName).
	! !

!SqBoardCompositePanel methodsFor: '*SqSquare-BrowserPlugin' stamp: 'mu 4/20/2006 17:15'!
loginAndSelectBoard
	"Called in Project entering"
	"Retrieve params from UIBuilder"

	self tryLogin: SqUIBuilder default userIdString.
	self waitTick.
	self selectBoard: SqUIBuilder default boardIdStirng.

	self extent: self world extent - 10.
	self center: self world center.! !

!ProjectLauncher methodsFor: '*SqSquare-BrowserPlugin' stamp: 'mu 4/20/2006 12:07'!
installSqSquareProjectFrom: loader
	self showSplashMorph.
	[[[
		loader installSqSquareProject
	] on: ProjectViewOpenNotification
	  do:[:ex| ex resume: false] "no project view in plugin launcher"
	] on: ProgressInitiationException "no 'reading aStream' nonsense"
	  do:[:ex| ex sendNotificationsTo: [ :min :max :curr |]]
	] on: SqBoardEntryNotification "hide splash morph when entering project"
       do:[:ex| self hideSplashMorph. ex pass].! !

!ProjectLauncher methodsFor: '*SqSquare-BrowserPlugin-override' stamp: 'mu 4/20/2006 12:19'!
startUpAfterLogin
	| scriptName loader isUrl |
	self setupFlaps.
	Preferences readDocumentAtStartup ifTrue: [
		HTTPClient isRunningInBrowser ifTrue:[
			self setupFromParameters.
			scriptName _ self parameterAt: 'src'.
			CodeLoader defaultBaseURL: (self parameterAt: 'Base').
		] ifFalse:[
			scriptName _ (SmalltalkImage current getSystemAttribute: 2) ifNil:[''].
			scriptName isEmpty ifFalse:[
				"figure out if script name is a URL by itself"
				isUrl _ (scriptName asLowercase beginsWith:'http://') or:[
						(scriptName asLowercase beginsWith:'file://') or:[
						(scriptName asLowercase beginsWith:'ftp://')]].
				isUrl ifFalse:[scriptName _ 'file:',scriptName]].
		]. ]
	ifFalse: [ scriptName := '' ].

	scriptName isEmptyOrNil
		ifTrue:[^Preferences eToyFriendly ifTrue: [self currentWorld addGlobalFlaps]].
	loader _ CodeLoader new.
	loader loadSourceFiles: (Array with: scriptName).

	(scriptName asLowercase endsWith: '.sqsq') ifTrue: [^self installSqSquareProjectFrom: loader].

	(scriptName asLowercase endsWith: '.pr') 
		ifTrue:[self installProjectFrom: loader]
		ifFalse:[loader installSourceFiles].
! !

!CodeLoader methodsFor: '*SqSquare-BrowserPlugin' stamp: 'mu 4/20/2006 12:06'!
installSqSquareProject
	"Assume that we're loading a single file and it's a project"
	| aStream data entryParams |
	aStream _ sourceFiles first contentStream.
	aStream ifNil:[^self error:'Project was not loaded'].

	data _ aStream contents asString.
	entryParams _ AbUtil readConfigurationFromStream: data unzipped readStream.
	
	entryParams at: #inform ifPresent: [:p | ^self error: p].
	
	SqUIBuilder default openProjectWith: entryParams.

	(SqBoardEntryNotification new entryParams: entryParams ) signal

	
	! !
